#include <stdio.h>
#include <math.h>
#include <strings.h>
#include "slist.h"
#include "skel.h"
#include "myvga.h"
#include "grfont.h"
#include "anaglyph.h"

#ifdef X86
#include <vga.h>
#endif


#define SOLID_BUFSIZE 1024

ana_append_buffer(FILE *mov, unsigned char *buff, int xres, int yres)
{
	fwrite(buff, 1, (xres ) * (yres ), mov); 
}

void ana_read_demo (char *buf)
{
	FILE *demofile;

	if ( (demofile = fopen("demoreel.keys", "r")) == NULL)
		buf = "";
	else
	   fscanf(demofile, "%s", buf);
	fclose(demofile);
}

void ana_write_demo (char *buf)
{
	FILE *demofile;

	if ((demofile = fopen("demoreel.keys", "w")) != NULL) {
	   	fprintf(demofile, "%s\n", buf);
		fclose(demofile);
	}
}




void draw_anaglyph(sl_screen *myscreen, camera *cam, simple_triangle_list *stl, simple_point_list *spl)
{

	// two camers, cam_left and cam_right, will be built from cam

        int x1, y1, x2, y2, x3, y3, t;
	FILE *moviefile;
	real theta, velocity, accel;
	char c, action, left_right, put_frame;
	v3 trans;
	d2 ta, tb, tc;
	int xres, yres, xres_1, yres_1;
	char buffer[SOLID_BUFSIZE];
	char grstat[40];
	int buffer_size, buffer_index, frames ;
	bool demo_mode;
	graphfont twelve, eight, seven, italics;
	camera *cam_left, *cam_right, *tempcam;

	simple_point_list *p_list;
	simple_triangle_list *tri_list;

	buffer_size = 0;
	demo_mode = false;

        printf("hello, world\n");

	if ((moviefile = fopen("movie.dat", "a")) == NULL)
		fprintf(stderr, "Could not open move file for writing!\n");

	twelve.initfont("fonts/font12.pbm");
	eight.initfont("fonts/font8.pbm");
	seven.initfont("fonts/font7.pbm");
	italics.initfont("fonts/italics.pbm");

	cam_left = new camera;
	cam_right = new camera;

	xres = cam->xres;
	yres = cam->yres;

	cam_left->zoom = cam_right->zoom = cam->zoom;
	cam_left->buffer = cam_right->buffer = cam->buffer;
	cam_left->xres = cam_right->xres = cam->xres;
	cam_left->yres = cam_right->yres = cam->yres;

	velocity = 0.0;
	accel = 0.1;

	xres_1 = xres - 1;
	yres_1 = yres - 1;
	
        theta = 0.0;
	frames = 0;
        c = 'X';
	put_frame = 'n';
        while ( c  != 'q')
        {
		frames++;
		action = 'y';
                switch (c) {
                //case '8': cam->position = cam->position + 
                 //       v3_scalar_mul(0.9, cam->forward);
                  //      break;
                //case '2': cam->position = cam->position - 
                        //v3_scalar_mul(0.9, cam->forward);
                        //break;
                case '8': velocity += accel;
                        break;
                case '2': velocity -= accel;
                        break;
                case '1': theta += 0.1;
                        cam->up = cam->up -
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case '3': theta -= 0.1;
                        cam->up = cam->up +
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case '4': theta += 0.1;
                        cam->forward = cam->forward -
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case '5': velocity = 0;
                        break;
                case '6': theta -= 0.1;
                        cam->forward = cam->forward +
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case 'a': cam->position = cam->position + 
                                v3_scalar_mul(0.3, cam->up);
                        break;
                case 'z': cam->position = cam->position - 
                                v3_scalar_mul(0.3, cam->up);
                        break;
                case 's': cam->forward = cam->forward + 
                                v3_scalar_mul(0.1, cam->up);
                        break;
                case 'x': cam->forward = cam->forward - 
                                v3_scalar_mul(0.1, cam->up);
                        break;
                case 'r': ana_read_demo(buffer);
			  demo_mode = true;
			  buffer_index = 0;
			  action = 'n';
                        break;
                case 'w': buffer[buffer_size] = (char) NULL;
			  ana_write_demo(buffer);
			  action = 'n';
                        break;
                case ' ': if (put_frame == 'y')
                		put_frame = 'n';
			  else
                		put_frame = 'y';
                        break;
                default:  
			 action = 'n';
                         break;
                }
		if ( (demo_mode == false) && (action == 'y')) {
			if (buffer_size > SOLID_BUFSIZE)
				buffer_size = 0;
			buffer[buffer_size++] = c;
		}

                // cam->position.x = sin(theta) * 9.0;
                // cam->position.z = - cos(theta) * 9.0;
                cam->make_m3();

                cam->position = cam->position + 
                        v3_scalar_mul(velocity, cam->forward);

		// now the left/right stuff begins...
		cam_left->up = cam_right->up = cam->up;
		cam_left->forward = cam_right->forward = cam->forward;
		cam_left->position = cam->position - v3_scalar_mul(ANA_DIST, cam->fxu);
		cam_right->position = cam->position + v3_scalar_mul(ANA_DIST, cam->fxu);
                cam_left->make_m3();
                cam_right->make_m3();
		

		// transform triangle's points in world coordinates
		// into camera coordinates (trans). 
                // Then project onto film: 3d->2d (proj).
		
		for (left_right = 'l'; left_right != 'n' ;)
		{
                	p_list = spl;
			if (left_right == 'l')
				tempcam = cam_left;
			else
				tempcam = cam_right;
			while (p_list != NULL)
			{
                        	// trans = p_list->p->pt;
                        	tempcam->cam_trans(&p_list->p->pt, p_list->p->trans);
				if (p_list->p->trans->z > 0.5) {
                                	tempcam->cam_proj(p_list->p->trans,
						&p_list->p->project );
					p_list->p->drawable = 'y';
				}
				else
				{
					tempcam->cam_proj(p_list->p->trans,
						&p_list->p->project );
					p_list->p->drawable = 'n';
				}
				p_list = p_list->next;
			} 
		
			// draw projected triangles
			tri_list = stl;
			//if (action == 'y') {
			if (1) {
				while (tri_list != NULL)
				{
					if (v3_dot(tri_list->tri->normal, tempcam->forward) > 0.0) 
					;
					{
						get_scanlines(myscreen, tri_list->tri, xres_1, yres_1);
					} // if dot prod.
					tri_list = tri_list->next;
		
				} // while triangles 
                        	endpoint_sort(myscreen);
				myscreen->draw_buffer_left_right(cam, left_right);
				if (left_right == 'r') {
					my_vga_blitscreen(cam->buffer, cam->xres, cam->yres);
					if (put_frame == 'y')
                				ana_append_buffer(moviefile, cam->buffer, xres, yres);
					my_vga_clearbuffer(cam->buffer, cam->xres, cam->yres);
				}
				myscreen->free_sorted_sl_nodes();
			} // if action
			if (left_right == 'r')
				left_right = 'n';
			if (left_right == 'l')
				left_right = 'r';
		} //for left_right
	 	if (demo_mode == false) 
			c = my_vga_getkey();
	   	else
			if ((c = buffer[buffer_index++]) == (char) NULL)
				demo_mode = false;
	} // while not q
	fclose(moviefile);
	tempcam->print();
	cam_left->print();
	cam_right->print();
	cam->print();

	printf("done!\n");
}


