#include <malloc.h>
#include <ctype.h>
#include "grfont.h"

void ppmcomment(char *fname, FILE *ppmfile);
int ppmnum(char *fname, FILE *ppmfile, char firstdigit);


void graphfont::initfont( char *filename)
{

	FILE *fontfile;
	char pbmtype[2], c;
	char waste[2048];
	int irows;
	int charheight;
	


	if ( ( fontfile = fopen(filename, "r") ) == NULL )
	{
		fprintf(stderr, "Couldn't open file name %s \n", filename);
		exit(0);
	}
	
	fread(pbmtype, 1, 2, fontfile);
	if ((pbmtype[0] != 'P') || (pbmtype[1] != '4')) {
		fprintf(stderr, "Not P4 type fontfile '%c%c' fontfile %s \n", pbmtype[0], pbmtype[1], filename);
		exit(0);
	}
        while ((c = fgetc(fontfile)) != EOF)
        {
                if (c == '#')
                        ppmcomment(filename, fontfile);
                else if (isdigit(c)) 
                {
                        cols = ppmnum(filename, fontfile, c);
                        break;
                }
        }
        while ((c = fgetc(fontfile)) != EOF)
        {
                if (c == '#')
                        ppmcomment(filename, fontfile);
                else if (isdigit(c))
                {
                        rows = ppmnum(filename, fontfile, c);   
                        break;
                }
        }
	charlen = cols / 96; // last char is del or something, 96 + 2 - 1(del or something)
	cols = cols; // - charlen;
	charheight = (rows + 1) / 2;
	buff = (unsigned char *) malloc ( rows * cols / 8);

	printf("rows: %d , cols: %d, charlen %d, charheight %d, filesize %d (%s) \n",
		rows, cols, charlen, charheight, rows * cols / 8, filename);
//        c = fgetc(fontfile);
//	printf("something is fucked '%d' '%c'", c, c);
 //       c = fgetc(fontfile);
//	printf("something is fucked '%d' '%c'", c, c);
	rows = charheight;
	for (irows = 0; irows < ( charheight / 2) ; irows++)
		fread(waste, 1 , cols / 8  , fontfile);
	fread(buff, 1, rows * cols / 8, fontfile);

	
}

void graphfont::printgraphbuf(unsigned char *vidbuff, int xres, int yres, int xpos, int ypos, char *string, char color)
{

	// nasty!  a character row may span multiple bits.
	// The row length is "charlen", the bitmap font is described
	// by rows, cols and charlen.  There are 

	unsigned char *upperleft;
	char current, fontbyte;
	int fontstartbit, byte1, byte2, byte3, sindex, byteremainder, bitcount, y;

	upperleft = vidbuff + xres * ypos + xpos;
	sindex = 0;

	while (current = string[sindex]) { 
		// top row
		for (y = 0 ; y < rows ; y++) {
			fontstartbit = (int) ( current - ' ') * charlen;
			upperleft = vidbuff + xres * ypos + xpos + charlen * sindex + xres * y;
			byte1 = (fontstartbit + cols * y )  / 8;
			byte2 = byte1 + 1;
			byte3 = byte2 + 1;
			byteremainder = fontstartbit % 8 ;
				fontbyte = *(buff + byte1)  << byteremainder;
				for ( bitcount = 0 ; bitcount < ( 8 -  byteremainder); bitcount++) {
					if (fontbyte & 0x80)
						*upperleft = color;
					fontbyte <<= 1;
					upperleft++;
				}
				fontbyte = *(buff + byte2);
				for ( bitcount = 0 ; bitcount < ( charlen - ( 8 -  byteremainder) ); bitcount++) {
					if (fontbyte & 0x80)
						*upperleft = color;
					fontbyte <<= 1;
					upperleft++;
				}
			//} else {  // three bytes =-( not happening yet, so it's wrong. =-(
				//fontbyte = *(buff + byte1)  << byteremainder;
				//for ( bitcount = 0 ; bitcount < ( 8 -  byteremainder); bitcount++) {
					//if (fontbyte & 0x80)
						//*upperleft = color;
					//fontbyte <<= 1;
					//upperleft++;
				//}
				//fontbyte = *(buff + byte2);
				//for ( bitcount = 0 ; bitcount < 8 ; bitcount++) {
					//if (fontbyte & 0x80)
						//*upperleft = color;
					//fontbyte <<= 1;
					//upperleft++;
				//}
				//fontbyte = *(buff + byte3);
				//for ( bitcount = 0 ; bitcount < ( byteremainder - 4 ); bitcount++) {
					//if (fontbyte & 0x80)
						//*upperleft = color;
					//fontbyte <<= 1;
					//upperleft++;
				//}
			//} // if remainder > 4
			
		}  // for rows
		sindex++;
	}  // for string
} // printgraphbuf
	 
void ppmcomment(char *fname, FILE *ppmfile)
{
        char c;

        while ((fread(&c, sizeof(char), 1, ppmfile)) == 1)
                if (c == '\n')
                        return;
}

void ppmerror(char *complaint, char *filename)
{
        fprintf(stderr, "ERROR: PPM file [%s]: %s\n", filename, complaint);
        exit(0);
}

int ppmnum(char *fname, FILE *ppmfile, char firstdigit)
{
        int result;
        unsigned char c;

        result = firstdigit - '0';
        c = fgetc(ppmfile);
        while (isdigit(c)) 
        {
                result = result * 10 + c - '0';
                c = fgetc(ppmfile);
        }
	printf("read '%c' (%d)\n", c , c);
        return result;
}
